//
//  ViewController.m
//  AreaAnalysis
//
//  Created by Ibokan on 15/8/28.
//  Copyright (c) 2015年 Crazy凡. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()
@property (weak, nonatomic) IBOutlet UIPickerView *pickerView;
@property (weak, nonatomic) IBOutlet UILabel *infoLabel;
@property (nonatomic,strong) NSArray *province;
@property (nonatomic,strong) NSMutableArray *tempdata;//装载当前省的全部数据
@property (nonatomic, strong) NSMutableArray  *pickerProvincesData;//当所有省的名称数据
@property (nonatomic, strong) NSMutableArray  *pickerCitiesData;//当前的省下面的市名称数据
@property (nonatomic, strong) NSMutableArray  *pickerDistrictData;//当前的市下面的区的名称数据
@property int ia,ib;
@end
@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.province = [[NSArray alloc]initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"area2.plist" ofType:nil]];
    self.pickerProvincesData = [[NSMutableArray alloc]init];
    self.pickerCitiesData = [[NSMutableArray alloc]init];
    self.pickerDistrictData = [[NSMutableArray alloc]init];
    self.tempdata = [[NSMutableArray alloc]init];
    for(int i = 0 ; i < self.province.count ; [self.pickerProvincesData addObjectsFromArray:[self.province[i++] allKeys]]);//取出所有的keys（省）仅有名称，数据部分是根据省动态获取的
    self.ia = self.ib = 0;
    [self getPickerCitiesData];//获取初始化市
    [self getPickerDistrictData];//获取初始化区
    self.pickerView.dataSource = self;
    self.pickerView.delegate = self;
    [self.infoLabel setText:[NSString stringWithFormat:@"%@;%@;%@",self.pickerProvincesData[[self.pickerView selectedRowInComponent:0]],self.pickerCitiesData[[self.pickerView selectedRowInComponent:1]],self.pickerDistrictData[[self.pickerView selectedRowInComponent:2]]]];//让label 显示选中的内容（初始化后显示）
}
- (void)getPickerCitiesData//装载市
{
    [self.pickerCitiesData removeAllObjects];//清除数据
    [self.tempdata removeAllObjects];//清除数据
    [self.tempdata addObjectsFromArray:[[NSArray alloc]initWithArray:[self.province[self.ia] valueForKey:self.pickerProvincesData[self.ia]]]];//将当前省的所有数据保存在一个数组中，避免反复读取
    for(NSDictionary *dir in self.tempdata) { [self.pickerCitiesData addObjectsFromArray:[dir allKeys]]; }//将市的名称取出
}
- (void)getPickerDistrictData//装载区
{
    [self.pickerDistrictData removeAllObjects];
    [self.pickerDistrictData addObjectsFromArray:[self.tempdata [self.ib]valueForKey:self.pickerCitiesData[self.ib]]];//填充区的名称
}
#pragma mark 实现协议UIPickerViewDataSource方法
- (NSInteger)numberOfComponentsInPickerView:(UIPickerView *)pickerView {return 3; }//设定有几列
- (NSInteger)pickerView:(UIPickerView *)pickerView numberOfRowsInComponent:(NSInteger)component {
    switch (component) {//设定每一列有多少行
        case 0: return self.pickerProvincesData.count; break;
        case 1: return self.pickerCitiesData.count; break;
        case 2: return self.pickerDistrictData.count; break;
        default: break;
    }
    return 0;
}
#pragma mark 实现协议UIPickerViewDelegate方法
-(NSString *)pickerView:(UIPickerView *)pickerView titleForRow:(NSInteger)row forComponent:(NSInteger)component {//设定行内容
    switch (component) {
        case 0: return [self.pickerProvincesData objectAtIndex:row]; break;
        case 1: return [self.pickerCitiesData objectAtIndex:row]; break;
        case 2: return [self.pickerDistrictData objectAtIndex:row]; break;
        default: break;
    }
    return 0;
}//设定行内容结束
- (void)pickerView:(UIPickerView *)pickerView  didSelectRow:(NSInteger)row inComponent:(NSInteger)component {
    switch (component) {//检测滑动事件（row 是行  component 是代表滚动的列）
        case 0:
            self.ia = (int) row;
            self.ib = 0;
            [self getPickerCitiesData];//重新装载城市数据
            [self getPickerDistrictData];//重新装载区数据
            [self.pickerView reloadComponent:1];//重新填充城市列表
            [self.pickerView reloadComponent:2];//重新填充城市列表
            break;
        case 1:
            self.ib = (int) row;
            [self getPickerDistrictData];
            [self.pickerView reloadComponent:2];
            break;
        default: break;
    }
    [self.infoLabel setText:[NSString stringWithFormat:@"%@;%@;%@",self.pickerProvincesData[[self.pickerView selectedRowInComponent:0]],self.pickerCitiesData[[self.pickerView selectedRowInComponent:1]],self.pickerDistrictData[[self.pickerView selectedRowInComponent:2]]]];//刷新 label 显示的内容 （每次滚动后刷新）
}
- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}
@end